library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity main is
	port (
				CLK		: in std_logic;
				RESET    : in std_logic;
				POSITION : out std_logic_vector(3 downto 0);
				DISPLAY  : out std_logic_vector(6 downto 0);
            CNTR_OVERFLOW : out std_logic -- indikace preteceni citace   
         );
end main;

architecture Behavioral of main is
-------------------------------------------------------------
--
--    KOMPONENTY
--		==========
-------------------------------------------------------------
component bcd_counter is
    Port ( CLK : in std_logic;
       --    CE  : in std_logic;
			  RESET : in std_logic;
           OUT_BUS : out std_logic_vector(3 downto 0);
			  CARRY_OUT : out std_logic
			);
end component;
-------------------------------------------------------------
component zobrazovac is
	generic (number_of_segments : integer := 4);
	port (	CLK : in std_logic;
				DIGITS  : in std_logic_vector((number_of_segments * 4)-1 downto 0);
				POSITION : out std_logic_vector(number_of_segments-1 downto 0);
				DISPLAY  : out std_logic_vector(6 downto 0)
			);
end component;
-------------------------------------------------------------
  component clk_divisor is
   generic (divisor : natural );
   port (
      CLK_INPUT  : in std_logic;
      RESET      : in std_logic;
      CLK_OUTPUT : out std_logic
   );
   end component;
-------------------------------------------------------------
	signal numbers : std_logic_vector(15 downto 0);
	signal bcd_carry : std_logic_vector(4 downto 0);
begin
-------------------------------------------------------------
--
-- Propojeni
--
-------------------------------------------------------------
i_Zobrazovac : zobrazovac
	port map (
	  	CLK => CLK,
		DIGITS => numbers,
		POSITION => POSITION,
		DISPLAY => DISPLAY
	);
-------------------------------------------------------------
i_Clk_Divisor : clk_divisor
   generic map (divisor => 5_000_000 ) -- citani po 0,1 s
   port map (
      CLK_INPUT => CLK,
      RESET     => RESET,
      CLK_OUTPUT => bcd_carry(0) -- vstup hodin do prvniho bloku citace
   );
   
--	numbers <= "0001001000110100";
BCD: for i in 0 to 3 generate
i_BCD: bcd_counter
	port map (
		CLK => bcd_carry(i),
		RESET => RESET,
      OUT_BUS => numbers(i*4+3 downto i*4),
		CARRY_OUT => bcd_carry(i+1)
	);
end generate;

CNTR_OVERFLOW <= bcd_carry(bcd_carry'high);
end Behavioral;
